



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>模块化JavaScript设计模式(一)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">模块化JavaScript设计模式(一)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-17 13:09:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>在可扩展JavaScript的世界里，假设我们说一个应用程序是模块化(modular)的，那么通常意味着它是由一系列存储于模块中的高度解耦，不同的功能片段组成。</p>
<p>在可能的情况下。通过一处依赖性。松耦合能够使应用程序的可维护性更加简单。 假设有效地实现了这点，就非常easy地了解一部分怎样影响还有一个部分。</p>
<p>异步模块定义（AMD）的总体目标是提供模块化的JavaScript解决方式。以便开发人员使用。诞生于使用XHR&#043;eval的Dojo开发经验。这样的&#26684;式的支持者希望可以避免未来的不论什么解决方式受到过去解决方式缺点的影响。 AMD模块&#26684;式本身就是对定义模块的建议，其模块和依赖都将可以进行异步载入。</p>
<p>AMD最開始是CommonJS重模块&#26684;式的草案规范，但因为没有达到广泛的一致，这样的&#26684;式的进一步发展就转移到了amdjs社区（https://github.com/amdjs）。</p>
<h1>一、模块入门</h1>
<p>关于AMD有两个关键概念是&#20540;得我们注意的，他们是用于模块定义的define方法和用于处理依赖载入的require方法。试用一下方法。define用于定义已命名或未命名模块：</p>
<p><pre class="prettyprint linenums">define(<br />
    module_id /*可选*/,<br />
    [dependencies] /*可选*/,<br />
    definition function /*function for instantiating the module or object实例化模块或对象的函数*/<br />
)</pre></p>
<p>module_id是一个可选參数。它通常仅仅在非AMD 连接工具被使用时才须要。当遗漏这个參数时。我们称这个模块未匿名的（anonymous）。</p>
<p>当使用这个匿名模块时。模块身份的概念是DRY，以便更easy避免文件名称和代码反复。由于代码变得更轻便了，不须要改动代码本身或改变其模块ID，就能够将它非常easy地移动到其它位置。</p>
<p>Developers能够只通过使用AMD优化器在多个环境中执行同样的代码，AMD优化器在CommonJS环境（譬如r.js https://github.com/jrburke/r.js/）下工作。</p>
<p><pre class="prettyprint linenums">       define (&quot;myModule&quot;,  //定义一个module<br />
            [&#039;foo&#039;, &#039;bar&#039;],<br />
            function (foo, bar) { //模块定义函数，依赖foo  bar 作为參数映射到函数上</pre>
<pre class="prettyprint linenums">                //这里创建你的模块<br />
                var myModule = {<br />
                    dostuff: function () {<br />
                        console.log(&#039;yay, stuff&#039;);<br />
                    }<br />
                };<br />
                return myModule;<br />
            }<br />
       );</pre>
<pre class="prettyprint linenums">       //第二种定义方式<br />
       define(&#039;myModule&#039;, [&#039;math&#039;, &#039;graph&#039;], function (math, graph) {<br />
            return {<br />
                plot: function(x, y) {<br />
                    return graph.drawPie(math.randomGrid(x, y));<br />
                }<br />
            }<br />
       });</pre>
<p>require通经常使用于载入顶级JavaScript文件或模块的代码。</p>
<p><pre class="prettyprint linenums">//foo bar是两个外部模块。两个模块载入以后输出作为回调函数的參数传入<br />
require([&#039;foo&#039;, &#039;bar&#039;], function (foo, bar) {<br />
    //<br />
    foo.doSomething();<br />
})</pre>
<p>动态载入依赖</p>
<p><pre class="prettyprint linenums">define(function (require) {<br />
    var isReady = false, foobar;<br />
    require([&#039;foo&#039;, &#039;bar&#039;], function (foo, bar) {<br />
        isReady = true;<br />
        foobar = foo() + bar();<br />
    });<br />
    return {<br />
        isReady: isReady,<br />
        foobar: foobar<br />
    }<br />
})</pre></p>
<p>了解 AMD： 插件</p>
<p><pre class="prettyprint linenums">//使用AMD能够载入随意格式的内容<br />
//这样的方式能够用于模板依赖，以便在页面载入的时候进行做换肤方面的工作<br />
define([&#039;./templates&#039;, &#039;text!./template.md&#039;, &#039;css!./template.css&#039;], function (templates, template) {<br />
    console.log(templates);<br />
});</pre></p>
<p>尽管在上面的演示样例重包括css。用于载入css依赖。但这样的方法会有一些警告。党css全然被载入时。它不一定全然生效。取决于怎样处理创建过程。它也可能使用css作为一个依赖文件而被包括在优化的文件里，因此。在将css作为载入依赖使用的情况下，一定要慎重。</p>
<p>该演示样例能够简单看作是requirejs(['app/myModule'], function () {})。表明载入器的顶级全局对象被使用。</p>
<p>这里演示了怎样使用不同的AMD载入器载入顶级模块nahor，通过使用define()函数，假设塔接受了一个本地模块參数。那么全部require([])的演示样例都适用于curl.js 和 RequireJS这两种类型的载入器。</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7lmjx8.html">swift-UserDefaults控制账号和密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r0oyd9.html">解决PHP大文件上传问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k22vr8.html">rabbitMQ学习（七）反馈模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/4954lnmq.html">jQuery 选择器语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qymm5xq.html">静态内部类和Lazy&amp;lt&semi;T&amp;gt&semi;优雅实现单例</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvgpkyq.html">JS之tagNaem和nodeName</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvv6mxq.html">Iterator之ListIterator简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0mvn4q.html">mysql 排重查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vde3o8.html">POJ 2101</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv35gjq.html">改善用户体验之wordpress添加图片弹出层效果 &lpar;插件 FancyBox）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z126219.html">C&num;正则表达式Regex类使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zvydj9.html">uva 1411 Ants</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jz7rv8.html">JVM的总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8megz10q.html">&lbrack;再寄小读者之数学篇&rsqb;&lpar;2014-06-20 求极限---Jordan 不等式的应用&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlll6vxq.html">&OpenCurlyDoubleQuote;笨方法&rdquo;学习Python笔记（1）-Windows下的准备</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zykvj39.html">Android包管理机制（二）PackageInstaller安装APK</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ogyxk8.html">exp导出数据时丢表</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w51ygq.html">bootstrap2&period;1相关文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e7nv19.html">PHP 中文字符串截取</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpd21z9.html">dede频道页实现三级栏目嵌套调用文章</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlmnkj69.html">我的日常工具&mdash;&mdash;gdb篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okv3k59.html">快速入门linux系统的iptables防火墙 1 本机与外界的基本通信管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd4622q.html">JavaIO之RandomAccessFile随机访问文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xmzjv8.html">golang实现ios推送</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd463xq.html">String - 兴趣解读</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wmgzvq.html">hadoop-1&period;2&period;0 eclipse插件编译</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdy6xd8.html">Weibo Crawler in Action</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvzj4oq.html">《学习OpenCV》练习题第四章第一题a</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn12lz28.html">ICON的设计很重要</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdymz48.html">类似于QQ游戏百万人同时在线的服务器架构实现</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
